Makefile.am 9.79 KB
Newer Older
1 2 3 4 5
# Ganeti makefile
# - Indent with tabs only.
# - Keep files sorted; one line per file.
# - Directories in lib/ must have their own *dir variable (see hypervisor).
# - All directories must be listed DIRS.
Michael Hanselmann's avatar
Michael Hanselmann committed
6
# - Use autogen.sh to generate Makefile.in and configure script.
7 8 9 10 11

# Automake doesn't export these variables before version 1.10.
abs_top_builddir = @abs_top_builddir@
abs_top_srcdir = @abs_top_srcdir@

12
ACLOCAL_AMFLAGS = -I autotools
13 14 15 16
DOCBOOK_WRAPPER = $(top_srcdir)/autotools/docbook-wrapper
REPLACE_VARS_SED = autotools/replace_vars.sed

hypervisordir = $(pkgpythondir)/hypervisor
17
httpdir = $(pkgpythondir)/http
18
rapidir = $(pkgpythondir)/rapi
19 20 21 22 23 24 25 26 27 28
toolsdir = $(pkglibdir)/tools
docdir = $(datadir)/doc/$(PACKAGE)

DIRS = \
	autotools \
	daemons \
	devel \
	doc \
	doc/examples \
	lib \
29
	lib/http \
30
	lib/hypervisor \
31
	lib/rapi \
32 33 34 35 36 37 38
	man \
	qa \
	scripts \
	test \
	test/data \
	tools

Iustin Pop's avatar
Iustin Pop committed
39
MAINTAINERCLEANFILES = \
40
	$(docpng) \
Iustin Pop's avatar
Iustin Pop committed
41 42
	$(maninput)

43 44 45
maintainer-clean-local:
	-rm -rf doc/api doc/build doc/html

46 47 48
CLEANFILES = \
	autotools/replace_vars.sed \
	devel/upload \
49
	doc/examples/bash_completion \
50 51 52
	doc/examples/ganeti.initd \
	doc/examples/ganeti.cron \
	lib/*.py[co] \
53
	lib/http/*.py[co] \
54
	lib/hypervisor/*.py[co] \
55
	lib/rapi/*.py[co] \
Iustin Pop's avatar
Iustin Pop committed
56 57
	$(man_MANS) \
	$(manhtml) \
58 59 60 61 62 63 64 65 66 67
	qa/*.py[co] \
	test/*.py[co] \
	stamp-directories \
	$(nodist_pkgpython_PYTHON)

nodist_pkgpython_PYTHON = \
	lib/_autoconf.py

pkgpython_PYTHON = \
	lib/__init__.py \
Guido Trotter's avatar
Guido Trotter committed
68
	lib/asyncnotifier.py \
69 70 71 72 73 74 75
	lib/backend.py \
	lib/bdev.py \
	lib/bootstrap.py \
	lib/cli.py \
	lib/cmdlib.py \
	lib/config.py \
	lib/constants.py \
76
	lib/daemon.py \
77 78
	lib/errors.py \
	lib/jqueue.py \
79
	lib/jstore.py \
80 81 82 83 84 85 86 87 88
	lib/locking.py \
	lib/luxi.py \
	lib/mcpu.py \
	lib/objects.py \
	lib/opcodes.py \
	lib/rpc.py \
	lib/serializer.py \
	lib/ssconf.py \
	lib/ssh.py \
89
	lib/storage.py \
90 91
	lib/utils.py \
	lib/workerpool.py
92 93 94 95

hypervisor_PYTHON = \
	lib/hypervisor/__init__.py \
	lib/hypervisor/hv_base.py \
96
	lib/hypervisor/hv_chroot.py \
97
	lib/hypervisor/hv_fake.py \
Guido Trotter's avatar
Guido Trotter committed
98
	lib/hypervisor/hv_kvm.py \
99 100
	lib/hypervisor/hv_xen.py

101 102
rapi_PYTHON = \
	lib/rapi/__init__.py \
103 104 105
	lib/rapi/baserlib.py \
	lib/rapi/connector.py \
	lib/rapi/rlib2.py
106

107
http_PYTHON = \
108
	lib/http/__init__.py \
109
	lib/http/auth.py \
110 111
	lib/http/client.py \
	lib/http/server.py
112

113

Michael Hanselmann's avatar
Michael Hanselmann committed
114
docrst = \
115
	doc/admin.rst \
116
	doc/design-2.0.rst \
117
	doc/design-2.1.rst \
118
	doc/glossary.rst \
119
	doc/hooks.rst \
120
	doc/iallocator.rst \
121
	doc/index.rst \
122
	doc/install.rst \
123
	doc/rapi.rst \
124
	doc/security.rst
Michael Hanselmann's avatar
Michael Hanselmann committed
125

126 127 128 129 130 131 132 133 134 135
doc/html: $(docrst) $(docpng) doc/conf.py configure.ac
	@test -n "$(SPHINX)" || \
	    { echo 'sphinx-build' not found during configure; exit 1; }
	mkdir -p doc/build/doctrees
	PYTHONPATH=.:$(top_builddir) sphinx-build -q -b html \
	    -d doc/build/doctrees \
	    -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
	    -D release="$(PACKAGE_VERSION)" \
	    $(top_srcdir)/doc doc/html
	touch "$@"
Iustin Pop's avatar
Iustin Pop committed
136

137 138 139
docdot = \
	doc/arch-2.0.dot

140
docpng = $(patsubst %.dot,%.png,$(docdot))
141

142
noinst_DATA = $(manhtml) doc/html
143

144 145 146 147
dist_sbin_SCRIPTS = \
	daemons/ganeti-noded \
	daemons/ganeti-watcher \
	daemons/ganeti-masterd \
148
	daemons/ganeti-rapi \
149 150 151 152 153 154 155 156 157 158 159 160 161 162 163
	scripts/gnt-backup \
	scripts/gnt-cluster \
	scripts/gnt-debug \
	scripts/gnt-instance \
	scripts/gnt-job \
	scripts/gnt-node \
	scripts/gnt-os

dist_tools_SCRIPTS = \
	tools/burnin \
	tools/cfgshell \
	tools/cfgupgrade \
	tools/lvmstrap

EXTRA_DIST = \
Iustin Pop's avatar
Iustin Pop committed
164
	$(MAINTAINERCLEANFILES) \
165 166
	NEWS \
	DEVNOTES \
Michael Hanselmann's avatar
Michael Hanselmann committed
167
	pylintrc \
168 169
	autotools/docbook-wrapper \
	devel/upload.in \
170
	$(docdot) \
171 172 173
	$(docrst) \
	doc/conf.py \
	doc/html \
174
	doc/examples/bash_completion.in \
175 176 177
	doc/examples/ganeti.initd.in \
	doc/examples/ganeti.cron.in \
	doc/examples/dumb-allocator \
178
	doc/locking.txt \
179 180 181 182 183
	test/testutils.py \
	test/mocks.py \
	$(dist_TESTS) \
	$(TEST_FILES) \
	man/footer.sgml \
Iustin Pop's avatar
Iustin Pop committed
184
	$(mansgml) $(maninput) \
185
	qa/ganeti-qa.py \
Michael Hanselmann's avatar
Michael Hanselmann committed
186
	qa/qa-sample.json \
187 188 189 190 191 192 193 194
	qa/qa_cluster.py \
	qa/qa_config.py \
	qa/qa_daemon.py \
	qa/qa_env.py \
	qa/qa_error.py \
	qa/qa_instance.py \
	qa/qa_node.py \
	qa/qa_os.py \
Oleksiy Mishchenko's avatar
Oleksiy Mishchenko committed
195
	qa/qa_rapi.py \
196 197 198 199 200
	qa/qa_tags.py \
	qa/qa_utils.py

man_MANS = \
	man/ganeti.7 \
201
	man/ganeti-masterd.8 \
202 203
	man/ganeti-noded.8 \
	man/ganeti-os-interface.7 \
204
	man/ganeti-rapi.8 \
205 206 207
	man/ganeti-watcher.8 \
	man/gnt-backup.8 \
	man/gnt-cluster.8 \
208
	man/gnt-debug.8 \
209
	man/gnt-instance.8 \
210
	man/gnt-job.8 \
211 212 213
	man/gnt-node.8 \
	man/gnt-os.8

Iustin Pop's avatar
Iustin Pop committed
214 215 216
mansgml = $(patsubst %.7,%.sgml,$(patsubst %.8,%.sgml,$(man_MANS)))
manhtml = $(patsubst %.sgml,%.html,$(mansgml))
maninput = $(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS))) $(patsubst %.html,%.html.in,$(manhtml))
217 218 219

TEST_FILES = \
	test/data/bdev-both.txt \
220
	test/data/bdev-8.3-both.txt \
221 222
	test/data/bdev-disk.txt \
	test/data/bdev-net.txt \
223 224
	test/data/proc_drbd8.txt \
	test/data/proc_drbd83.txt
225 226

dist_TESTS = \
227 228 229
	test/ganeti.bdev_unittest.py \
	test/ganeti.cli_unittest.py \
	test/ganeti.cmdlib_unittest.py \
230
	test/ganeti.config_unittest.py \
231
	test/ganeti.constants_unittest.py \
232
	test/ganeti.hooks_unittest.py \
233
	test/ganeti.http_unittest.py \
234
	test/ganeti.locking_unittest.py \
235
	test/ganeti.objects_unittest.py \
236
	test/ganeti.rapi.resources_unittest.py \
237 238 239 240
	test/ganeti.serializer_unittest.py \
	test/ganeti.ssh_unittest.py \
	test/ganeti.utils_unittest.py \
	test/ganeti.workerpool_unittest.py
241 242 243 244 245

nodist_TESTS =

TESTS = $(dist_TESTS) $(nodist_TESTS)

246
TESTS_ENVIRONMENT = PYTHONPATH=.:$(top_builddir) $(PYTHON)
247

248
all-local: stamp-directories lib/_autoconf.py devel/upload \
Iustin Pop's avatar
Iustin Pop committed
249
	doc/examples/bash_completion \
250 251 252 253 254 255
	doc/examples/ganeti.initd doc/examples/ganeti.cron

devel/upload: devel/upload.in stamp-directories $(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@
	chmod u+x $@

Iustin Pop's avatar
Iustin Pop committed
256
doc/examples/%: doc/examples/%.in stamp-directories \
257 258 259
		$(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@

260
doc/%.png: doc/%.dot
Iustin Pop's avatar
Iustin Pop committed
261
	@test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
262 263
	$(DOT) -Tpng -o $@ $<

Iustin Pop's avatar
Iustin Pop committed
264
man/%.7.in man/%.8.in: man/%.sgml man/footer.sgml $(DOCBOOK_WRAPPER)
265
	@test -n "$(DOCBOOK2MAN)" || { echo 'docbook2html' not found during configure; exit 1; }
Iustin Pop's avatar
Iustin Pop committed
266 267 268 269 270 271 272
	TMPDIR=`mktemp -d` && { \
	$(DOCBOOK_WRAPPER) "$(DOCBOOK2MAN)" $< $$TMPDIR/$(patsubst man/%.in,%,$@) ; \
	mv $$TMPDIR/$(patsubst man/%.in,%,$@) $@ ; \
	rm -rf "$$TMPDIR" ; \
	}

man/%.html.in: man/%.sgml man/footer.sgml $(DOCBOOK_WRAPPER)
273
	@test -n "$(DOCBOOK2HTML)" || { echo 'docbook2html' not found during configure; exit 1; }
Iustin Pop's avatar
Iustin Pop committed
274 275 276 277 278 279 280 281
	TMPDIR=`mktemp -d` && { \
	$(DOCBOOK_WRAPPER) "$(DOCBOOK2HTML) --nochunks" $< $$TMPDIR/$(patsubst man/%.in,%,$@) ; \
	mv $$TMPDIR/$(patsubst man/%.in,%,$@) $@ ; \
	rm -rf "$$TMPDIR" ; \
	}

man/%.7: man/%.7.in stamp-directories $(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@
282

Iustin Pop's avatar
Iustin Pop committed
283 284
man/%.8: man/%.8.in stamp-directories $(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@
285

Iustin Pop's avatar
Iustin Pop committed
286 287
man/%.html: man/%.html.in stamp-directories $(REPLACE_VARS_SED)
	sed -f $(REPLACE_VARS_SED) < $< > $@
288

289 290
man/footer.sgml $(TESTS): srclinks

291
$(TESTS): ganeti lib/_autoconf.py
292 293 294 295 296

lib/_autoconf.py: Makefile stamp-directories
	set -e; \
	{ echo '# This file is automatically generated, do not edit!'; \
	  echo '#'; \
Iustin Pop's avatar
Iustin Pop committed
297 298 299 300 301 302 303 304 305
	  echo ''; \
	  echo '"""Build-time configuration for Ganeti.'; \
	  echo '';\
	  echo 'This file is autogenerated by the build process.'; \
	  echo 'For any changes you need to re-run ./configure (and'; \
	  echo 'not edit by hand).'; \
	  echo ''; \
	  echo '"""'; \
	  echo ''; \
306 307 308 309 310 311 312 313 314 315 316 317 318 319 320
	  echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
	  echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
	  echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
	  echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
	  echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
	  echo "VERSION_FULL = '$(VERSION_FULL)'"; \
	  echo "LOCALSTATEDIR = '$(localstatedir)'"; \
	  echo "SYSCONFDIR = '$(sysconfdir)'"; \
	  echo "SSH_INITD_SCRIPT = '$(SSH_INITD_SCRIPT)'"; \
	  echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
	  echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
	  echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
	  echo "XEN_INITRD = '$(XEN_INITRD)'"; \
	  echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
	  echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
321
	  echo "KVM_PATH = '$(KVM_PATH)'"; \
Guido Trotter's avatar
Guido Trotter committed
322
	  echo "KVM_MIGRATION_PORT = '$(KVM_MIGRATION_PORT)'"; \
Guido Trotter's avatar
Guido Trotter committed
323
	  echo "SOCAT_PATH = '$(SOCAT_PATH)'"; \
324
	  echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)" ; \
325 326 327 328 329 330 331 332 333 334 335
	} > $@

$(REPLACE_VARS_SED): Makefile stamp-directories
	set -e; \
	{ echo 's#@PREFIX@#$(prefix)#g'; \
	  echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
	  echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
	  echo 's#@SBINDIR@#$(sbindir)#g'; \
	  echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
	  echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
	  echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
336
	  echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
337 338 339 340 341 342 343
	} > $@

# We need to create symlinks because "make distcheck" will not install Python
# files when building.
#.PHONY: srclinks
srclinks: stamp-directories
	set -e; \
344 345
	for i in man/footer.sgml $(pkgpython_PYTHON) $(hypervisor_PYTHON) \
			$(rapi_PYTHON) $(http_PYTHON); do \
346 347 348 349
		if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
			$(LN_S) $(abs_top_srcdir)/$$i $$i; \
		fi; \
	done
350

Michael Hanselmann's avatar
Michael Hanselmann committed
351 352
.PHONY: ganeti
ganeti:
353
	cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
Michael Hanselmann's avatar
Michael Hanselmann committed
354

Iustin Pop's avatar
Iustin Pop committed
355 356 357 358 359 360 361
# a dist hook rule for catching revision control directories
distcheck-hook:
	if find $(top_distdir) | grep -F -e '.svn' -e '.git'; then \
		echo "Found revision control files in final archive" 1>&2 ; \
		exit 1; \
	fi

Iustin Pop's avatar
Iustin Pop committed
362
install-exec-local:
363
	@mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
364 365
	  "$(DESTDIR)${localstatedir}/log/ganeti" \
	  "$(DESTDIR)${localstatedir}/run/ganeti"
366 367 368 369 370

stamp-directories: Makefile
	@mkdir_p@ $(DIRS)
	touch $@

Iustin Pop's avatar
Iustin Pop committed
371 372 373
.PHONY: apidoc
apidoc:
	test -e doc/api || mkdir doc/api
Iustin Pop's avatar
Iustin Pop committed
374
	TMPDIR=`mktemp -d ` && { \
Iustin Pop's avatar
Iustin Pop committed
375 376
		cp -r scripts daemons lib $$TMPDIR && \
		( \
Iustin Pop's avatar
Iustin Pop committed
377
			CDIR=`pwd` && \
Iustin Pop's avatar
Iustin Pop committed
378 379
			cd $$TMPDIR && \
			mv lib ganeti && \
Iustin Pop's avatar
Iustin Pop committed
380
			epydoc -v --conf $$CDIR/epydoc.conf -o $$CDIR/doc/api \
Iustin Pop's avatar
Iustin Pop committed
381 382 383 384
		) ; \
		rm -rf $$TMPDIR ; \
	}

385 386 387 388 389 390 391
.PHONY: TAGS
TAGS:
	rm -f TAGS
	find . -path './lib/*.py' -o -path 'scripts/gnt-*' -o \
	  -path 'daemons/ganeti-*' -o -path 'tools/*' | \
	  etags -

392
# vim: set noet :